; Wizualizacja zawartoci pamici flash na linijce LED
; Rafa Baranowski (C) 2004

.INCLUDE "m16def.inc"

	ldi	R16, 0xFF
	out	DDRA, R16		; port PA pracuje w trybie wyjciowym

	ldi	R16, 0x0F
	out	PORTB, R16		; podciganie na liniach PB0..3 wczone

	ldi	ZL, low(0)		; rejestr indeksowy Z wskazuje na modszy bajt
	ldi 	ZH, high(0)		;   pierwszej komrki pamici programu

Petla:
	lpm	R0, Z+		; odczyt komrki pamici flash wskazywanej przez
					;   rejestr indeksowy Z i jego postinkrementacja
	out	PORTA, R0		; wywietlenie odczytanej wartoci na linijce
					;   diodowej, doczonej do portu PA

Czekaj_na_S1:
	sbic	PINB, PINB0		; oczekiwanie na wcinicie klawisza S1,
	rjmp	Czekaj_na_S1	;   doczonego do linii PB0

	lpm	R0, Z+
	out	PORTA, R0		; wywietlenie zawartoci nastpnej komrki

Czekaj_na_S5:
	sbic	PINB, PINB1		; oczekiwanie na wcinicie klawisza S5,
	rjmp	Czekaj_na_S5	;   doczonego do linii PB1

	rjmp	Petla			; zaptlenie programu (skok do instrukcji
					;   nastpujcej po etykiecie "Petla")
